private boolean mIsUsingPen = false;

#if USE_SPEN
private SPenEventLibrary mSPenEventLibrary;

private void InitSPen()
{
	mSPenEventLibrary = new SPenEventLibrary();
	mSPenEventLibrary.setSPenTouchListener(this, new SPenTouchListener(){

		@Override
		public boolean onTouchFinger(View view, MotionEvent event) {
			DrawingWithMaskView v = (DrawingWithMaskView)view;
			v.mIsUsingPen = false;
			v.onTouchEvent(event);
			return true;
		}

		@Override
		public boolean onTouchPen(View view, MotionEvent event) {
			DrawingWithMaskView v = (DrawingWithMaskView)view;
			v.mIsUsingPen = true;
			v.onTouchEvent(event);
			return true;
		}

		@Override
		public boolean onTouchPenEraser(View view, MotionEvent event) {
			return true;
		}

		@Override
		public void onTouchButtonDown(View view, MotionEvent event) {
		}

		@Override
		public void onTouchButtonUp(View view, MotionEvent event) {
		}

	});
	
	mSPenEventLibrary.setSPenHoverListener(this, new SPenHoverListener(){
		@Override
		public boolean onHover(View view, MotionEvent event) {
			DrawingWithMaskView v = (DrawingWithMaskView)view;
			v.onTouchEvent(event);
			return true;
		}
		
		public void onHoverButtonDown(View view, MotionEvent event) {
		}
		
		@Override
		public void onHoverButtonUp(View view, MotionEvent event) {
		}
	});
}
#endif