float mLastSpenPointerX = 0;
float mLastSpenPointerY = 0;

#define PAINT_ATCION_NONE	0
#define PAINT_ATCION_DOWN	1
#define PAINT_ATCION_MOVE	2
#define PAINT_ATCION_UP		3

#define ACTION_HOVER_ENTER 9
#define ACTION_HOVER_MOVE 7
#define ACTION_HOVER_EXIT 10

private boolean OnTouch(MotionEvent ev)
{
	int action = ev.getAction();
	float eventX = ev.getX();
	float eventY = ev.getY();
	ev.setLocation(eventX + MyActivity.s_Activity.mDrawingViewX, eventY + MyActivity.s_Activity.mDrawingViewY);
	MyActivity.s_Activity.onTouch(this,ev);
	
	if (mEnableTouch == false) 
	{
		// forward msg
		if (mConfig_SimulateSpray)
		{
			if (action == ACTION_HOVER_MOVE)
			{
				if (eventX > 0 && eventY > 0 && eventX < mDisplayBitmap.getWidth() && eventY < mDisplayBitmap.getHeight())
				{
					mLastSpenPointerX = eventX;
					mLastSpenPointerY = eventY;
					ev.setAction(MotionEvent.ACTION_MOVE);
					MyActivity.s_Activity.onTouch(this,ev);
				}
				
			}
			else if (action == ACTION_HOVER_EXIT)
			{
				ev.setLocation(mLastSpenPointerX + MyActivity.s_Activity.mDrawingViewX, mLastSpenPointerY + MyActivity.s_Activity.mDrawingViewY);
				ev.setAction(MotionEvent.ACTION_UP);
				MyActivity.s_Activity.onTouch(this,ev);
			}
			else if (action == ACTION_HOVER_ENTER)
			{
				if (eventX > 0 && eventY > 0 && eventX < mDisplayBitmap.getWidth() && eventY < mDisplayBitmap.getHeight())
				{
					mLastSpenPointerX = eventX;
					mLastSpenPointerY = eventY;
					ev.setAction(MotionEvent.ACTION_DOWN);
					MyActivity.s_Activity.onTouch(this,ev);
				}
			}
		}
		return true;
	}

	
	int paintAction = PAINT_ATCION_NONE;
	
	// System.out.println("********************************* "  + action);
	
	boolean simulateForce = true;
	switch (action) 
	{
		case MotionEvent.ACTION_DOWN:
			paintAction = PAINT_ATCION_DOWN;
			if (mConfig_DisableFinger && !mIsUsingPen)
			{
				paintAction = PAINT_ATCION_NONE;
			}
			if (mConfig_DisableSpenTouch)
			{
				paintAction = PAINT_ATCION_NONE;
			}
			if (mConfig_SimulateSpray)
			{
				simulateForce = false;
			}
			break;
		case MotionEvent.ACTION_MOVE: 
			paintAction = PAINT_ATCION_MOVE;
			if (mConfig_DisableFinger && !mIsUsingPen)
			{
				paintAction = PAINT_ATCION_NONE;
			}
			if (mConfig_DisableSpenTouch)
			{
				paintAction = PAINT_ATCION_NONE;
			}
			if (mConfig_SimulateSpray)
			{
				simulateForce = false;
			}
			break;
		case MotionEvent.ACTION_UP: 
			paintAction = PAINT_ATCION_UP;
			if (mConfig_DisableFinger && !mIsUsingPen)
			{
				paintAction = PAINT_ATCION_NONE;
			}
			if (mConfig_DisableSpenTouch)
			{
				paintAction = PAINT_ATCION_NONE;
			}
			if (mConfig_SimulateSpray)
			{
				simulateForce = false;
			}
			break;
		case ACTION_HOVER_ENTER:
			if (mConfig_SimulateSpray)
			{
				simulateForce = true;
				if (eventX > 0 && eventY > 0 && eventX < mDisplayBitmap.getWidth() && eventY < mDisplayBitmap.getHeight())
				{
					mLastSpenPointerX = eventX;
					mLastSpenPointerY = eventY;
					ev.setAction(MotionEvent.ACTION_DOWN);
					MyActivity.s_Activity.onTouch(this,ev);
				}
			}
			break;
		case ACTION_HOVER_MOVE:
			if (mConfig_SimulateSpray)
			{
				paintAction = PAINT_ATCION_MOVE;
				simulateForce = true;
				if (eventX > 0 && eventY > 0 && eventX < mDisplayBitmap.getWidth() && eventY < mDisplayBitmap.getHeight())
				{
					mLastSpenPointerX = eventX;
					mLastSpenPointerY = eventY;
					ev.setAction(MotionEvent.ACTION_MOVE);
					MyActivity.s_Activity.onTouch(this,ev);
				}
				
			}
			break;
		case ACTION_HOVER_EXIT:
			if (mConfig_SimulateSpray)
			{
				ev.setLocation(mLastSpenPointerX + MyActivity.s_Activity.mDrawingViewX, mLastSpenPointerY + MyActivity.s_Activity.mDrawingViewY);
				paintAction = PAINT_ATCION_UP;
				simulateForce = true;
				ev.setAction(MotionEvent.ACTION_UP);
				MyActivity.s_Activity.onTouch(this,ev);
			}
			break;
	}
	
	switch (paintAction) 
	{
		case PAINT_ATCION_DOWN: 
		{
			mHasPaint = true;
			mX = (int) eventX;
			mY = (int) eventY;
			mLastX = INF;
			mLastY = INF;	
			if (simulateForce && mConfig_SimulateSpray)
			{
				mBrushForce = 1;
			}
			else
			{
				mBrushForce = 0;
			}
			break;
		}

		case PAINT_ATCION_MOVE: 
		{
			mHasPaint = true;
			mX = (int) eventX;
			mY = (int) eventY;
			if (simulateForce)
			{
				int d = Math.abs(mLastX - mX) + Math.abs(mLastY - mY);
				if (d < 5)
				{
					mBrushForce ++;
				}
				else {
					d = 0;
				}
			}
			else
			{
				mBrushForce = 0;
			}
			break;
		}           

		case PAINT_ATCION_UP:
			mHasPaint = false;
			mX = INF;
			mY = INF;
			mLastX = INF;
			mLastY = INF;
			if (simulateForce && mConfig_SimulateSpray)
			{
				mBrushForce = 1;
			}
			else
			{
				mBrushForce = 0;
			}
			break;
	}
	return true;
}