#include "plugin_registerHandler.h"
#include "plugin_registerActivityResult.h"


private AlertDialog m_Alert;
private Handler m_Handler;
private RelativeLayout m_MyLayout;
static MyActivity s_Activity = null;

void SendMessge(int msg)
{
	Message newMsg = m_Handler.obtainMessage(msg);
	m_Handler.sendMessage(newMsg);
}

void SendMessge(int msg, int arg)
{
	Message newMsg = m_Handler.obtainMessage(msg, arg, 0);
	m_Handler.sendMessage(newMsg);
}

void SendMessge(int msg, int arg1, int arg2)
{
	Message newMsg = m_Handler.obtainMessage(msg,arg1, arg2);
	m_Handler.sendMessage(newMsg);
}

void SendMessge(int msg, int arg1, int agr2, Object obj)
{
	Message newMsg = m_Handler.obtainMessage(msg, arg1, agr2, obj);
	m_Handler.sendMessage(newMsg);
}

void SendMessge(int msg, Object obj)
{
	Message newMsg = m_Handler.obtainMessage(msg, obj);
	m_Handler.sendMessage(newMsg);
}

void PluginInit()
{
	s_Activity = this;
		
	AlertDialog.Builder builder = new AlertDialog.Builder(this);
	builder.setMessage("Would you like to quit game?")
		.setCancelable(false)
		.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int id) {
#if USE_ADMOB
				Admob_Destroy();
#endif
				int pid = android.os.Process.myPid(); 
				android.os.Process.killProcess(pid); 
			}
		})
		.setNegativeButton("No", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int id) {
				dialog.cancel();
			}
		});
	m_Alert = builder.create();

	m_MyLayout = new RelativeLayout (this);  
	m_MyLayout.setLayoutParams(new LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.FILL_PARENT));  
	m_MyLayout.addView(mGLView);
	
	WebView_Init();
	Video_Init();

	setContentView(m_MyLayout);
	
	NativeInit();

#if USE_ADMOB
	NativeInitAdmob();
#endif	
	
	m_Handler = new Handler() {
		@Override
		public void handleMessage(Message msg) {
			LogI("[Handler] handleMessage() " + msg.what);
#if USE_BLUETOOTH
			Bluetooth_HandleMessage(msg);
#endif
#if USE_WIFI_DIRECT
			WifiDirect_HandleMessage(msg);
#endif
#if USE_INMOBI_LTVP		
			InMobi_handler(msg);
#endif
	
			switch (msg.what) {
				case MSG_SHOW_EXIT_DIAG:
					m_Alert.show();
					break;
#if USE_ADMOB
				case MSG_INIT_ADMOB:
					if (m_AdmobView == null)
					{
						m_AdmobView = new AdView(s_Activity, AdSize.BANNER, TOSTRING(ADMOB_PUBID));
						if (m_AdmobView != null && m_MyLayout != null)
						{
							AdRequest request = new AdRequest();
							request.addTestDevice("7E7252D148CD8539736B99B1E258938A");
							m_AdmobView.loadAd(request);
							RelativeLayout.LayoutParams params = new RelativeLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
							params.leftMargin = 0;
							params.topMargin = 0;
							m_MyLayout.addView(m_AdmobView, params);
						}
					}
					break;
				case MSG_ADMOB_HIDE:
					if (m_AdmobView != null && m_MyLayout != null)
					{
						try
						{
							m_MyLayout.removeView(m_AdmobView);
						}
						catch (Exception E)
						{
							E.printStackTrace();
						}
					}
					break;
				case MSG_ADMOB_SHOW:
					if (m_AdmobView != null && m_MyLayout != null)
					{	
						RelativeLayout.LayoutParams params = new RelativeLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
						params.leftMargin = s_Activity.m_iAdmobViewX;
						params.topMargin = s_Activity.m_iAdmobViewY;
						try
						{
							m_MyLayout.removeView(m_AdmobView);
						}
						catch (Exception E)
						{}
						m_MyLayout.addView(m_AdmobView, params);
						
					}
					break;
#endif						


				
				case MSG_DRAWINGWITHMASKVIEW_SHOW:
					s_Activity._DrawingWithMaskView_Show();
					break;
				case MSG_DRAWINGWITHMASKVIEW_HIDE:
					s_Activity._DrawingWithMaskView_Hide();
					break;
				case MSG_OPEN_LIBRARY:
					Intent i = new Intent(MyActivity.this, CGalleryPage.class);
					startActivity(i);
					break;
				case MESSAGE_WEBVIEW_SHOW:
					isShowingWebView = true;
					m_MyLayout.addView(myWebView);
					break;
				case MESSAGE_WEBVIEW_HIDE:
					myWebView.loadUrl("");
					isShowingWebView = false;
					m_MyLayout.removeView(myWebView);
					break;
					
				default:
					break;
			}
		}
	};
	
	// register ringer-mode changed
	IntentFilter filter=new IntentFilter(AudioManager.RINGER_MODE_CHANGED_ACTION);
	registerReceiver(mRingerReceiver,filter);
}

private final BroadcastReceiver mRingerReceiver = new BroadcastReceiver() 
{
	@Override
	public void onReceive(Context context, Intent intent) 
	{
		String params[] = {"mode", GetRingerMode() + ""};
		DispatchLua("gGameInstance", "OnRingerModeChanged", params);
	}
};

void PluginDestroy()
{
	Log("onDestroy");
#if USE_ADMOB
	Admob_Destroy();
#endif

#if USE_FLURRY
	Flurry_endSession();
#endif

	try
	{
		this.unregisterReceiver(mRingerReceiver);
	}
	catch(Exception E) 
	{}
}

public static String GetDeviceModel()
{
	String device =  ""
					+	android.os.Build.BOARD + "\n"
					+	android.os.Build.BOOTLOADER + "\n"
					+	android.os.Build.BRAND + "\n"
					+ 	android.os.Build.CPU_ABI + "\n"
					+ 	android.os.Build.CPU_ABI2 + "\n"
					+ 	android.os.Build.DEVICE + "\n"
					+ 	android.os.Build.DISPLAY + "\n"
					+ 	android.os.Build.FINGERPRINT + "\n"
					+ 	android.os.Build.HARDWARE + "\n"
					+ 	android.os.Build.HOST + "\n"
					+ 	android.os.Build.ID + "\n"
					+ 	android.os.Build.MANUFACTURER + "\n"
					+ 	android.os.Build.MODEL + "\n"
					+ 	android.os.Build.PRODUCT + "\n"
					+ 	"none" + "\n"
					+ 	android.os.Build.TAGS + "\n"
					+ 	android.os.Build.TYPE + "\n"
					+ 	android.os.Build.VERSION.SDK_INT + "\n"
					+ 	android.os.Build.USER  + "\n" 
					+ 	Environment.getExternalStorageDirectory().toString() + "//Android//data//" + TOSTRING(ANDROID_PACKAGE_NAME) + "//" + "\n" 
#if USE_INSTALLER
					+ 	Installer.sInstallerPackageW + "\n"
					+ 	Installer.sInstallerPackageH + "\n"
					+ 	Installer.sInstallerCompatMode + "\n"
					+ 	(Installer.sTimeStamp == 0?0:((System.currentTimeMillis() - Installer.sTimeStamp)/1000)) + "\n"
#else
					+ 	"0" + "\n"
					+ 	"0" + "\n"
					+ 	"1" + "\n"
					+ 	"0" + "\n"
#endif
					+ 	"" + "\n";
	Log("Call GetDeviceModel: "  + device);
	return device;
}

public static String GetDeviceMacAdress()
{
	Log("Call GetDeviceMacAdress: ");
	try
	{
		WifiManager wifiManager = (WifiManager) s_Activity.getSystemService(Context.WIFI_SERVICE);
		WifiInfo wInfo = wifiManager.getConnectionInfo();
		String macAddress = wInfo.getMacAddress(); 
		if (macAddress == null)
		{
			return "";
		}
		else
		{
			return macAddress;
		}
	}
	catch (Exception E)
	{
	}
	return "";
}

public static String GetDeviceID()
{
	Log("Call GetDeviceID: ");
	try
	{
		TelephonyManager telephonyManager = (TelephonyManager)s_Activity.getSystemService(Context.TELEPHONY_SERVICE);
		if (telephonyManager != null)
		{
			String devid = telephonyManager.getDeviceId();
			if (devid == null)
			{
				return "";
			}
			else
			{
				return devid;
			}
		}
	}
	catch (Exception E)
	{
		E.printStackTrace();
	}
	return "";
}

public static void Quit()
{
	Log("Invoke Quit");
	#if USE_ADMOB
		Admob_Destroy();
	#endif
	int pid = android.os.Process.myPid(); 
	android.os.Process.killProcess(pid); 
}

public static void ShowExitConfirmDialog()
{
	Log("Invoke ShowExitConfirmDialog");
	if (s_Activity != null)
	{
		s_Activity._ShowExitConfirmDialog();
	}
}

public void _ShowExitConfirmDialog()
{
	MyActivity.s_Activity.SendMessge(MSG_SHOW_EXIT_DIAG);
}


public static int GetRingerMode()
{
	Log("Invoke GetRingerMode");
	if (s_Activity != null)
	{
		return s_Activity._GetRingerMode();
	}
	return 0;
}

public int _GetRingerMode()
{
	AudioManager am = (AudioManager)getSystemService(Context.AUDIO_SERVICE);
	if (am != null)
	{
		switch (am.getRingerMode()) {
			case AudioManager.RINGER_MODE_SILENT:
				return 2;
			case AudioManager.RINGER_MODE_VIBRATE:
				return 1;
			case AudioManager.RINGER_MODE_NORMAL:
				return 0;
		}
	}
	return 0;
}

private void copyFile(InputStream in, OutputStream out) throws IOException {
	byte[] buffer = new byte[1024];
	int read;
	while((read = in.read(buffer)) != -1){
	  out.write(buffer, 0, read);
	}
}

File CacheFileFromAssetToSDCard(final String filename) {
	try {
		String extension = "";
		String hash = md5(filename);

		int i = filename.lastIndexOf('.');
		if (i > 0) {
			extension = filename.substring(i+1);
		}
		if (extension == "jet") {
			extension = filename.substring(0, i-1);
			i = extension.lastIndexOf('.');
			if (i > 0) {
				extension = extension.substring(i+1);
			}
		}
		hash = hash + "." + extension;

		String path = Environment.getExternalStorageDirectory().toString() + "//Android//data//" + TOSTRING(ANDROID_PACKAGE_NAME) + "//" + TOSTRING(VERSION_NAME) + "//_asset//" + hash;

		LogI("[CacheFileFromAssetToSDCard] cache file " + path);

		File file = new File(path);


		if (file.exists() && file.canRead()) {
			LogI("[CacheFileFromAssetToSDCard] cached file founded");
			return file;
		}

		File directory = new File(path).getParentFile();
		if (!directory.exists() && !directory.mkdirs())
		{
			LogI("[CacheFileFromAssetToSDCard] ERROR path file could not create " + path);
			return null;
		}
		
		AssetManager assetManager = s_Activity.getAssets();

		LogI("[CacheFileFromAssetToSDCard] create new cache file");
		InputStream in = null;

		

		try {
			in = assetManager.open(filename);
		}
		catch (Exception E) {
			try {
				in = assetManager.open(filename + ".jet");
			}
			catch (Exception E2) {
				LogI("[CacheFileFromAssetToSDCard] ERROR path file could not found " + filename);
				return null;
			}
		}

		file.createNewFile();
		OutputStream out = new FileOutputStream(file);
		copyFile(in, out);
		in.close();
		in = null;
		out.flush();
		out.close();
		out = null;

		return file;

	} catch (IOException e) {
		e.printStackTrace();
		return null;
	}
}

static boolean sRequireCapture = false;
static String sRequireCaptureFilename = "noname";
static int sRequireCaptureWidth = 0;
static int sRequireCaptureHeight = 0;
public static void CaptureScreen(String filename, int width, int height)
{
	sRequireCapture = true;
	sRequireCaptureFilename = filename;
	sRequireCaptureWidth = width;
	sRequireCaptureHeight = height;
}


static String SaveBitmap(Bitmap bitmap, String dir, String baseName, boolean auto_incr) 
{
	try 
	{
		dir = "guava7/gallery/" + TOSTRING(GAME_NAME) + "/" + dir;
		LogI("SaveBitmap: " + dir + "/" + baseName + "?.png");
		
		File sdcard = Environment.getExternalStorageDirectory();
		File pictureDir = new File(sdcard, dir);
		pictureDir.mkdirs();
		File f = null;
		if (auto_incr)
		{
			for (int i = 1; i < 1024; ++i) {
				String name = baseName + i + ".png";
				f = new File(pictureDir, name);
				if (!f.exists()) {
					break;
				}
			}
			if (!f.exists()) {
				String name = f.getAbsolutePath();
				FileOutputStream fos = new FileOutputStream(name);
				bitmap.compress(Bitmap.CompressFormat.PNG, 100, fos);
				fos.flush();
				fos.close();
				LogI("SaveBitmap: Sucessful with name " + name);
				return name;
			}
		}
		else
		{
			String name = baseName + ".png";
			f = new File(pictureDir, name);
			name = f.getAbsolutePath();
			FileOutputStream fos = new FileOutputStream(name);
			bitmap.compress(Bitmap.CompressFormat.PNG, 100, fos);
			fos.flush();
			fos.close();
			LogI("SaveBitmap: Sucessful with name " + name);
			return name;
		}
		LogI("SaveBitmap: Failed, out of slot");
	} catch (Exception e) {
		LogI("SaveBitmap: Failed !");
		e.printStackTrace();
	} finally {
		/*
		if (fos != null) {
			fos.close();
		}
		*/
	}
	return null;
}

static void OpenLibrary()
{
	MyActivity.s_Activity.SendMessge(MSG_OPEN_LIBRARY);
}

static void CallLua(String func, String[] p)
{
	if (p == null)
	{
		NativeLuaBridgeCallNoParam(func);
	}
	else
	{
		NativeLuaBridgeCall(func, p);
	}
}

static void CallLua(String func)
{
	NativeLuaBridgeCallNoParam(func);
}

static void DispatchLua(String receiver, String func, String[] keys_value)
{
	NativeLuaBridgeDispatchEvent(receiver, func, keys_value);
}

static void DispatchLua(String receiver, String func)
{
	String keys_value[] = {};
	NativeLuaBridgeDispatchEvent(receiver, func, keys_value);
}

static private Bitmap GetBitmapFromAsset(String strName)
{
	android.content.res.AssetManager assetManager = s_Activity.getAssets();
	InputStream istr = null;
	try {
		istr = assetManager.open(strName);
	} catch (IOException e) {
		e.printStackTrace();
	}
	Bitmap bitmap = BitmapFactory.decodeStream(istr);
	return bitmap;
}

public static final String md5(final String s) {
	try {
		// Create MD5 Hash
		java.security.MessageDigest digest = java.security.MessageDigest
				.getInstance("MD5");
		digest.update(s.getBytes());
		byte messageDigest[] = digest.digest();

		// Create Hex String
		StringBuffer hexString = new StringBuffer();
		for (int i = 0; i < messageDigest.length; i++) {
			String h = Integer.toHexString(0xFF & messageDigest[i]);
			while (h.length() < 2)
				h = "0" + h;
			hexString.append(h);
		}
		return hexString.toString();

	} catch (Exception e) {
		e.printStackTrace();
	}
	return "";
}

static public int HasInstalledApp(String uri)
{
	android.content.pm.PackageManager pm = s_Activity.getPackageManager();
	boolean app_installed = false;
	try
	{
		pm.getPackageInfo(uri, 	android.content.pm.PackageManager.GET_ACTIVITIES);
		app_installed = true;
	}
	catch (	android.content.pm.PackageManager.NameNotFoundException e)
	{
		   app_installed = false;
	}
	return app_installed?1:0;
}


public static native void NativeInit();
public static native void NativeLuaBridgeCall(String func, String[] params);
public static native void NativeLuaBridgeCallNoParam(String func);
public static native void NativeLuaBridgeDispatchEvent(String receiver, String func, String[] kv);


#include "plugin_DrawWithMaskView.h"
#include "plugin_Bluetooth.h"
#include "plugin_WifiDirect.h"
#include "plugin_Fortumo.h"
#include "plugin_chartboost.h"
#include "plugin_Flurry.h"
#include "plugin_InMobi.h"
#include "plugin_Amazon_iap.h"
#include "plugin_inmobi_ads.h"
#include "plugin_ShareAction.h"
#include "plugin_heyzap_ads.h"
#include "plugin_playphone.h"
#include "plugin_webview.h"
#include "plugin_FB.h"
#include "plugin_Parse.h"
#include "plugin_LocalNotif.h"
#include "plugin_Paypal.h"
#include "plugin_googleplayservice.h"
#include "plugin_Bastion.h"
#include "plugin_videoview.h"
#include "plugin_mobiroo.h"


/**/
public static void  InitCrittercism()
{
	#if USE_CRITTERCISM
		Crittercism.initialize(s_Activity.getApplicationContext(), TOSTRING(USE_CRITTERCISM_APP_ID));
	#endif
}
