#if USE_BASTION
	@Override
	public void onRedeemOffer(Offer offer)
	{}

	public static void Bastion_RedeemCode(final String code) {
		s_Activity.runOnUiThread(new Runnable() {
			public void run() {
				Bastion.redeemCode(code, new BastionCodeListener()
				{
					@Override
					public void onRedeemCodeSuccess(String code, Offer offer)
					{
						try {
							JSONObject offer_property_json = new JSONObject();
							Map<String, String> offer_params = offer.getOfferAdditionalParameters() ;
							for (Map.Entry<String, String> entry : offer_params.entrySet())
							{
								offer_property_json.put(entry.getKey(), entry.getValue());
							}
							LogI( "[Bastion] Offer property: " + offer_property_json.toString(2) );

							org.json.JSONArray offer_item_json = new org.json.JSONArray();
							for(Feature feature : offer.getFeatures())
							{
								String featureRef = feature.getReference();
								String value = feature.getValue();
								JSONObject obj = new JSONObject();
								obj.put("feature", featureRef);
								obj.put("value", value);
								offer_item_json.put(obj);
							}

							for(Resource resource : offer.getResources() )
							{
								String resourceRef = resource.getReference();
								int quantity = resource.getQuantity();
								JSONObject obj = new JSONObject();
								obj.put("resource", resourceRef);
								obj.put("quantity", quantity);
								offer_item_json.put(obj);
							}
							LogI( "[Bastion] Offer items: " + offer_item_json.toString(2) );

							MyActivity.DispatchLua("Bastion","bridge_OnBastionRedeemCompleted", new String[]{
								"errorCode","0", 
								"property", offer_property_json.toString(),
								"offer", offer_item_json.toString()
							});
						}
						catch(Exception E) {
							MyActivity.DispatchLua("Bastion","bridge_OnBastionRedeemCompleted", new String[]{
								"errorCode","-1", 
								"errorMsg", "Server response invalid data",
							});
						}
					}


					@Override
					public void onRedeemCodeFailed(String code, FailReason reason, CodeErrorInfo infos)
					{
						String message = "";
						String errno = "0";
						if (reason == FailReason.INVALID_CODE) {
							message = "Invalid code";
							errno = "1";
						}
						else if (reason == FailReason.MISMATCH_CONDITIONS) {
							message = "Invalid code";
							errno = "2";
						}
						else if (reason == FailReason.INVALID_API_KEY  || reason == FailReason.DEACTIVATED_API_KEY ) {
							message = "Invalid code";
							errno = "3";
						}
						else if (reason == FailReason.NETWORK_ERROR ) {
							message = "Network error";
							errno = "4";
						}
						else {
							errno = "-1";
							message = "Unknown error";
						}
						LogI("[onRedeemCodeFailed] code " + code + " FailReason " + reason + " CodeErrorInfos " + infos);
						MyActivity.DispatchLua("Bastion","bridge_OnBastionRedeemCompleted", new String[]{"errorCode",errno, "errorMsg", message});
					}
				});
			}
		});
	}

	// The listener of your app called when a user hit the restore button
	public static void Bastion_Restore()
	{
		s_Activity.runOnUiThread(new Runnable() {
			public void run() {
				Bastion.restore(new BastionRestoreListener()
				{
					@Override
					public void onRestoreSucceed(List<Feature> features, List<Resource> resources)
					{
						try {
							org.json.JSONArray offer_item_json = new org.json.JSONArray();
							for(Feature feature : features)
							{
								String featureRef = feature.getReference();
								String value = feature.getValue();
								JSONObject obj = new JSONObject();
								obj.put("feature", featureRef);
								obj.put("value", value);
								offer_item_json.put(obj);
							}

							for(Resource resource : resources )
							{
								String resourceRef = resource.getReference();
								int quantity = resource.getQuantity();
								JSONObject obj = new JSONObject();
								obj.put("resource", resourceRef);
								obj.put("quantity", quantity);
								offer_item_json.put(obj);
							}
							LogI( "[Bastion] Offer restored items: " + offer_item_json.toString(2) );

							MyActivity.DispatchLua("Bastion","bridge_OnBastionRestoreCompleted", new String[]{
								"errorCode","0", 
								"offer", offer_item_json.toString()
							});
						}
						catch(Exception E) {
							MyActivity.DispatchLua("Bastion","bridge_OnBastionRestoreCompleted", new String[]{
								"errorCode","-1", 
								"errorMsg", "Server response invalid data",
							});
						}
					}

					@Override
					public void onRestoreFailed(FailReason reason)
					{
						String message = "";
						String errno = "0";
						if (reason == FailReason.INVALID_CODE) {
							message = "Invalid code";
							errno = "1";
						}
						else if (reason == FailReason.MISMATCH_CONDITIONS) {
							message = "Invalid code";
							errno = "2";
						}
						else if (reason == FailReason.INVALID_API_KEY  || reason == FailReason.DEACTIVATED_API_KEY ) {
							message = "Invalid code";
							errno = "3";
						}
						else if (reason == FailReason.NETWORK_ERROR ) {
							message = "Network error";
							errno = "4";
						}
						else {
							errno = "-1";
							message = "Unknown error";
						}
						LogI("[onRestoreFailed] FailReason " + reason);
						MyActivity.DispatchLua("Bastion","bridge_OnBastionRestoreCompleted", new String[]{"errorCode",errno, "errorMsg", message});
					}
				});
			}
		});
	}
#endif