public DrawingWithMaskView m_DrawingView = null;
public int mDrawingViewX = 0;
public int mDrawingViewY = 0;

public static void DrawingWithMaskView_Init(String displayImage, String maskImage, int initColor, int initSize)
{
	LogI("DrawingWithMaskView_Init " + displayImage + " " + maskImage +  " " + initColor + " " + initSize);
	if (s_Activity.m_DrawingView == null)
	{
		s_Activity.m_DrawingView = new DrawingWithMaskView(s_Activity);
	}
	s_Activity.m_DrawingView.Reset();
	s_Activity.m_DrawingView.SetDisplayBitmap(displayImage);
	s_Activity.m_DrawingView.SetMaskBitmap(maskImage);
	s_Activity.m_DrawingView.SetBrushSize(initSize);
	s_Activity.m_DrawingView.SetBrushColor(0xFFFFFF, initColor);
}

public static void DrawingWithMaskView_Show(int x, int y)
{
	LogI("DrawingWithMaskView_Show " + x + " " + y);
	s_Activity.mDrawingViewX = x;
	s_Activity.mDrawingViewY = y;
	Message newMsg = s_Activity.m_Handler.obtainMessage(MSG_DRAWINGWITHMASKVIEW_SHOW);
	s_Activity.m_Handler.sendMessage(newMsg);
}

public void _DrawingWithMaskView_Show()
{
	int x = mDrawingViewX;
	int y = mDrawingViewY;
	if (m_DrawingView != null) 
	{
		m_MyLayout.removeView(m_DrawingView);
		RelativeLayout.LayoutParams params = new RelativeLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
		params.leftMargin = x;
		params.topMargin = y;
		m_MyLayout.addView(m_DrawingView, params);
	}
}

public static void DrawingWithMaskView_Hide()
{
	Message newMsg = s_Activity.m_Handler.obtainMessage(MSG_DRAWINGWITHMASKVIEW_HIDE);
	s_Activity.m_Handler.sendMessage(newMsg);
}

public void _DrawingWithMaskView_Hide()
{
	if (m_DrawingView != null) 
	{
		try
		{
			m_MyLayout.removeView(m_DrawingView);
		}
		catch (Exception E)
		{}
	}
}


public static void DrawingWithMaskView_Reset()
{
	if (s_Activity.m_DrawingView != null) 
	{
		s_Activity.m_DrawingView.Reset();
	}
}

public static void DrawingWithMaskView_SetBrushSize(int size)
{
	if (s_Activity.m_DrawingView != null)
	{
		s_Activity.m_DrawingView.SetBrushSize(size);
	}
}

public static void DrawingWithMaskView_SetBrushColor(int color, int maskColor)
{
	if (s_Activity.m_DrawingView != null)
	{
		s_Activity.m_DrawingView.SetBrushColor(color, maskColor);
	}
}

public static void DrawingWithMaskView_EnableTouch(int val)
{
	if (s_Activity.m_DrawingView != null)
	{
		s_Activity.m_DrawingView.EnableTouch(val == 0?true:false);
	}
}

public static int DrawingWithMaskView_GetPercentCompleted()
{
	if (s_Activity.m_DrawingView != null)
	{
		return (int)s_Activity.m_DrawingView.GetCompletionPercentage();
	}
	return 0;
}

public static void DrawingWithMaskView_SetCustomBitmapBrush(String url, int rows, int cols)
{
	
	if (s_Activity.m_DrawingView != null)
	{
		s_Activity.m_DrawingView.SetCustomBitmapBrush(url, rows, cols);
	}
}

public static void DrawingWithMaskView_SetFlags(int flags, int value)
{
	if (s_Activity.m_DrawingView != null)
	{
		s_Activity.m_DrawingView.SetFlags(flags, value == 0? false:true);
	}
}

public static void DrawingWithMaskView_SaveToLibrary(String folder, String basename, String bg)
{
	if (s_Activity.m_DrawingView != null)
	{
		s_Activity.m_DrawingView.SaveToLibrary(folder, basename, bg);
	}
}







