static void Flurry_startSession(String apiKey)
{
#if USE_FLURRY
	LogI("[Flurry_startSession] apiKey " + apiKey);
	FlurryAgent.setReportLocation(false);
	FlurryAgent.onStartSession(s_Activity, apiKey);
	FlurryAgent.setLogEvents(true);
#	if !RELEASE_MODE
	FlurryAgent.setLogEnabled(true);
    FlurryAgent.setLogLevel(Log.VERBOSE);
#	endif
#else
	LogI("[Flurry_startSession] USE_FLURRY is OFF !!!");
#endif
}

static void Flurry_endSession()
{
#if USE_FLURRY
	LogI("[Flurry_endSession]");
	FlurryAgent.onEndSession(s_Activity);
#endif
}

static void Flurry_logEvent(String eventId, String params_format, int timed)
{
#if USE_FLURRY
	LogI("[Flurry_logEvent] eventId " + eventId + "\n" + params_format);
	if (params_format.length() > 0)
	{
		String[] p = params_format.split("\n");
		Map<String, String> params = new HashMap<String, String>();
		for (int i = 0; i < p.length/2; i++)
		{
			params.put(p[i << 1], p[(i<<1) + 1]);
			LogI(p[i << 1] + ":" + p[(i<<1) + 1]);
		}
		boolean timeEvent = timed == 0?false:true;
		if (timeEvent)
		{
			FlurryAgent.logEvent(eventId, params, true);
		}
		else
		{
			FlurryAgent.logEvent(eventId, params);
		}
	}
	else
	{
		LogI("no param");
		boolean timeEvent = timed == 0?false:true;
		if (timeEvent)
		{
			FlurryAgent.logEvent(eventId, true);
		}
		else
		{
			FlurryAgent.logEvent(eventId);
		}
	}
	LogI("timed: " + (timed == 0?false:true));
#else
	LogI("[Flurry_startSession] USE_FLURRY is OFF !!!");
#endif
}


static void Flurry_endTimedEvent(String eventId, String params_format)
{
#if USE_FLURRY
	LogI("[Flurry_endTimedEvent] eventId " + eventId);
	if (params_format.length() >= 2)
	{
		String[] p = params_format.split("\n");
		Map<String, String> params = new HashMap<String, String>();
		for (int i = 0; i < p.length/2; i++)
		{
			params.put(p[i << 1], p[(i<<1) + 1]);
			LogI(p[i << 1] + ":" + p[(i<<1) + 1]);
		}
		FlurryAgent.endTimedEvent(eventId, params);
	}
	else
	{
		LogI("no param");
		FlurryAgent.endTimedEvent(eventId);
	}
#else
	LogI("[Flurry_startSession] USE_FLURRY is OFF !!!");
#endif
}