#if USE_INMOBI
private Map<String, Object> mLTVPActions;
#endif

static void InMobi_logEvent(String eventId, String params_format)
{
#if USE_INMOBI_EVENT_TRACKING
	LogI("[InMobi_logEvent] eventId " + eventId + "\n" + params_format);
	Map<String, String> params = new HashMap<String, String>();
	if (params_format.length() > 0)
	{
		String[] p = params_format.split("\n");
		
		for (int i = 0; i < p.length/2; i++)
		{
			params.put(p[i << 1], p[(i<<1) + 1]);
			LogI(p[i << 1] + ":" + p[(i<<1) + 1]);
		}
	}
	else
	{
		LogI("no param");
	}
	InMobiAnalytics.tagEvent(eventId, params);
#else
	LogI("[InMobi_logEvent] USE_INMOBI_EVENT_TRACKING is OFF !!!");
#endif
}

static int InMobi_showAction(final String slotID)
{
#if USE_INMOBI_LTVP
	LogI("[InMobi_showAction] slotID = " + slotID);
	Object o = s_Activity.mLTVPActions.get(slotID);
	if (o != null)
	{
		if (o instanceof IMInterstitial)
		{
			final IMInterstitial _interstitial = (IMInterstitial)o;
			if(_interstitial.getState() == IMInterstitial.State.READY)
			{
				s_Activity.runOnUiThread(new Runnable() {
					public void run() {
						_interstitial.show();
						s_Activity.mLTVPActions.remove(slotID);
						LogI("[InMobi_showAction] slotID = " + slotID + " --> Success");
						MyActivity.DispatchLua("gGameInstance","bridge_OnInMobiShowAction", new String[]{"errorCode", "0", "slotID", slotID});
					}
				});
				return 1;
			}
			else
			{
				LogI("[InMobi_showAction] slotID = " + slotID + " --> failed " + _interstitial.getState());
				MyActivity.DispatchLua("gGameInstance","bridge_OnInMobiShowAction", new String[]{"errorCode", "1", "slotID", slotID, "errorMessage", "IMInterstitial not ready"});
			}
		}
		else
		{
			junit.framework.Assert.fail ("Not support INMOBI LTVP as banner. Support Interstitial only");
		}
	}
	else
	{
		LogI("[InMobi_showAction] slotID = " + slotID + " not found");
		MyActivity.DispatchLua("gGameInstance","bridge_OnInMobiShowAction", new String[]{"errorCode", "1", "slotID", slotID, "errorMessage", "slot ID not found"});
	}
	return 0;
#else
	LogI("[InMobi_showAction] USE_INMOBI_LTVP is OFF !!!");
	return 0;
#endif
}

static void InMobi_loadAction(String slotID, int width, int height)
{
#if USE_INMOBI_LTVP
	LogI("[InMobi_loadAction] slotID = " + slotID + " width = " + width + " height = " + height );
	boolean isInterstitial = (width <= 0) || (height <= 0);
	Object o = s_Activity.mLTVPActions.get(slotID);
	if (o == null)
	{
		if (isInterstitial)
		{
			s_Activity.SendMessge(MSG_INMOBI_LTVP_REGISTER_INTERSTITIAL_ACTION, slotID);
		}
		else
		{
			// IMLTVPBanner banner = new IMLTVPBanner(s_Activity, TOSTRING(USE_INMOBI_APPID), ID);
			// o = banner;
			// banner.loadAction();
			junit.framework.Assert.fail ("Not support INMOBI LTVP as banner. Support Interstitial only");
		}
	}
	else
	{
		s_Activity.SendMessge(MSG_INMOBI_LTVP_LOAD_INTERSTITIAL_ACTION, slotID);
	}
#else
	LogI("[InMobi_loadAction] USE_INMOBI_LTVP is OFF !!!");
#endif
}

void InMobi_handler(Message msg)
{
#if USE_INMOBI_LTVP
	switch (msg.what) {
		case MSG_INMOBI_LTVP_REGISTER_INTERSTITIAL_ACTION:
			final String slotID = (String)msg.obj;
			long ID = 0;
			try
			{
				ID = Long.valueOf(slotID);
			}
			catch (Exception E)
			{
				E.printStackTrace();
				junit.framework.Assert.fail ("[InMobi_handler] invalid slotID " + slotID);
			}
			LogI("[InMobi_handler] MSG_INMOBI_LTVP_REGISTER_INTERSTITIAL_ACTION " + ID);
			IMInterstitial  interstitial  =  new IMInterstitial(this, ID);
			interstitial.setIMInterstitialListener(new IMInterstitialListener() {
				@Override
				public void onInterstitialLoaded(IMInterstitial lminterstitial){
					LogI("[InMobi] onInterstitialLoaded");
					MyActivity.DispatchLua("gGameInstance","bridge_OnInMobiAction", new String[]{"errorCode", "0", "slotID", slotID});
				}

				@Override
				public void onInterstitialFailed(IMInterstitial interstitial, IMErrorCode errorCode) {
					LogI("[InMobi] onInterstitialFailed " + errorCode);
					MyActivity.DispatchLua("gGameInstance","bridge_OnInMobiAction", new String[]{"errorCode", "1", "slotID", slotID, "IMErrorCode", errorCode + ""});
				}

				@Override
				public void onShowInterstitialScreen(IMInterstitial interstitial) {
					LogI("IMInterstitial onShowInterstitialScreen");
				}

				@Override
				public void onDismissInterstitialScreen(IMInterstitial interstitial) {
					LogI("IMInterstitial onDismissInterstitialScreen");
				}

				@Override
				public void onInterstitialInteraction(IMInterstitial interstitial, Map<String, String> arg1) {
					if (arg1.get("accepted").equals("true")) 
					{
						LogI("Details of Accepted Action:" + arg1.get("data"));
						MyActivity.DispatchLua("gGameInstance","bridge_OnInMobiAcceptAction", new String[]{"data", arg1.get("data") + "", "id", slotID});
					}
					else
					{
						LogI("Details of Rejected Action:" + arg1.get("data"));
						MyActivity.DispatchLua("gGameInstance","bridge_OnInMobiRejectAction", new String[]{"data", arg1.get("data") + "", "id", slotID});

					}
				}

				@Override
				public void onLeaveApplication(IMInterstitial interstitial) {}
			});

			this.mLTVPActions.put(slotID, interstitial);
			interstitial.loadInterstitial();
			break;

		case MSG_INMOBI_LTVP_LOAD_INTERSTITIAL_ACTION:
			final String slotID2 = (String)msg.obj;
			IMInterstitial im = (IMInterstitial)s_Activity.mLTVPActions.get(slotID2);
			if(im != null && im.getState() != IMInterstitial.State.READY && im.getState() != IMInterstitial.State.LOADING)
			{
				im.loadInterstitial();
			}
			break;
	}
#endif
}

void InMobi_init()
{
#if USE_INMOBI
	String apiKey = TOSTRING(USE_INMOBI_APPID);
	LogI("[InMobi_startSession] apiKey " + apiKey);
	InMobi.initialize(this, apiKey);

#	if !RELEASE_MODE
	InMobi.setLogLevel(InMobi.LOG_LEVEL.VERBOSE);
#	else
	InMobi.setLogLevel(InMobi.LOG_LEVEL.NONE);
#	endif

#endif
}

void InMobi_startSession()
{
#if USE_INMOBI_EVENT_TRACKING
	LogI("[InMobi_startSession]");

	// InMobiAnalytics.startSessionManually(getApplicationContext());
	InMobiAnalytics.startSessionManually();
	mLTVPActions = new HashMap<String, Object>();
#else
	LogI("[InMobi_startSession] USE_INMOBI_EVENT_TRACKING is OFF !!!");
#endif
}

void InMobi_endSession()
{
#if USE_INMOBI_EVENT_TRACKING
	LogI("[InMobi_endSession]");
	InMobiAnalytics.endSessionManually();
#endif
}