static void SendLocalNotif(final String id, final String title, final String message, final String sec)
{
	s_Activity._SendLocalNotif(Integer.parseInt(id), title, message, Integer.parseInt(sec));
}

static void CancelLocalNotif(String _id)
{
	LogI("[CancelLocalNotif] " + _id);
	final int id = Integer.parseInt(_id);
	s_Activity.runOnUiThread(new Runnable() {
		public void run() {
			try
			{
				Intent intent = new Intent(s_Activity, CLocalNotificationHandler.class);
				PendingIntent pendingIntent = PendingIntent.getBroadcast(s_Activity, id, intent, 0);
				AlarmManager alarmManager = (AlarmManager)s_Activity.getSystemService(Context.ALARM_SERVICE);
				alarmManager.cancel(pendingIntent);

				String ns = Context.NOTIFICATION_SERVICE;
				NotificationManager nMgr = (NotificationManager) s_Activity.getSystemService(ns);
				nMgr.cancel(id);
			}
			catch (Exception E)
			{
				E.printStackTrace();
			}
		}
	});
}


void _SendLocalNotif(final int id, final String title, final String message, final int sec)
{
	LogI("[SendLocalNotif] " + id + " " + title + " " + message + " " + sec);
	s_Activity.runOnUiThread(new Runnable() {
		public void run() {
			try
			{
				// Get new calendar object and set the date to now
				Calendar calendar = Calendar.getInstance();
				calendar.setTimeInMillis(System.currentTimeMillis());

				// Retrieve alarm manager from the system
				AlarmManager alarmManager = (AlarmManager) s_Activity.getSystemService(s_Activity.ALARM_SERVICE);

				// Prepare the intent which should be launched at the date
				Intent intent = new Intent(s_Activity, CLocalNotificationHandler.class);
				intent.putExtra("id", id);
				intent.putExtra("title", title);
				intent.putExtra("message", message);

				// Prepare the pending intent
				PendingIntent pendingIntent = PendingIntent.getBroadcast(s_Activity, id, intent, PendingIntent.FLAG_UPDATE_CURRENT);

				// Register the alert in the system. You have the option to define if the device has to wake up on the alert or not
				alarmManager.set(AlarmManager.RTC_WAKEUP, calendar.getTimeInMillis() + sec*1000, pendingIntent);
			}
			catch (Exception E)
			{
				E.printStackTrace();
			}
		}
	});
}


/*
void _SendLocalNotif(final int id, final String title, final String message)
{
	s_Activity.runOnUiThread(new Runnable() {
		public void run() {
			try
			{
				LogI("[SendLocalNotif] " + id + " " + title + " " + message);
				NotificationCompat.Builder mBuilder =
					new NotificationCompat.Builder(s_Activity)
					.setSmallIcon(R.drawable.icon)
					.setContentTitle(title)
					.setContentText(message);
					
				// Creates an explicit intent for an Activity in your app
				Intent resultIntent = new Intent(s_Activity, MyActivity.class);

				// The stack builder object will contain an artificial back stack for the
				// started Activity.
				// This ensures that navigating backward from the Activity leads out of
				// your application to the Home screen.
				TaskStackBuilder stackBuilder = TaskStackBuilder.create(s_Activity);
				// Adds the back stack for the Intent (but not the Intent itself)
				stackBuilder.addParentStack(MyActivity.class);
				// Adds the Intent that starts the Activity to the top of the stack
				stackBuilder.addNextIntent(resultIntent);
				PendingIntent resultPendingIntent = stackBuilder.getPendingIntent(
														0,
														PendingIntent.FLAG_UPDATE_CURRENT
													);
				mBuilder.setContentIntent(resultPendingIntent);
				NotificationManager mNotificationManager = (NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);
				
				// mId allows you to update the notification later on.
				mNotificationManager.notify(id, mBuilder.build());
			}
			catch (Exception E)
			{
				E.printStackTrace();
			}
		}
	});
}

*/


