
String mPaypalAPI_ClientID = "";

private String Paypal_GetClientID()
{
	#if USE_IAP_SANDBOX
		return TOSTRING(USE_PAYPAL_API_SANDBOX_CLIENTID);
	#else
		return  TOSTRING(USE_PAYPAL_API_SANDBOX_CLIENTID);
	#endif 
}

void Paypal_OnCreate()
{
#if USE_PAYPAL_API
	Intent intent = new Intent(this, PayPalService.class);

	#if USE_IAP_SANDBOX
		// intent.putExtra(PaymentActivity.EXTRA_PAYPAL_ENVIRONMENT, PaymentActivity.ENVIRONMENT_NO_NETWORK);
		intent.putExtra(PaymentActivity.EXTRA_PAYPAL_ENVIRONMENT, PaymentActivity.ENVIRONMENT_SANDBOX);	
	#endif 

	intent.putExtra(PaymentActivity.EXTRA_SKIP_CREDIT_CARD, true);	
	intent.putExtra(PaymentActivity.EXTRA_CLIENT_ID, Paypal_GetClientID());

	startService(intent);
#endif
}

void Paypal_OnDestroy()
{
#if USE_PAYPAL_API
	stopService(new Intent(this, PayPalService.class));
#endif
}

void _Paypal_Buy(String price, String currency, String productname, String userID) {
#if USE_PAYPAL_API
	PayPalPayment payment = new PayPalPayment(new BigDecimal(price), currency, productname);

    Intent intent = new Intent(this, PaymentActivity.class);

#if USE_IAP_SANDBOX
    // comment this line out for live or set to PaymentActivity.ENVIRONMENT_SANDBOX for sandbox
    // intent.putExtra(PaymentActivity.EXTRA_PAYPAL_ENVIRONMENT, PaymentActivity.ENVIRONMENT_NO_NETWORK);
    intent.putExtra(PaymentActivity.EXTRA_PAYPAL_ENVIRONMENT, PaymentActivity.ENVIRONMENT_SANDBOX);
#endif

    intent.putExtra(PaymentActivity.EXTRA_SKIP_CREDIT_CARD, true);	

    // it's important to repeat the clientId here so that the SDK has it if Android restarts your
    // app midway through the payment UI flow.
    intent.putExtra(PaymentActivity.EXTRA_CLIENT_ID, Paypal_GetClientID());

    // Provide a payerId that uniquely identifies a user within the scope of your system,
    // such as an email address or user ID.
    intent.putExtra(PaymentActivity.EXTRA_PAYER_ID, userID);

    intent.putExtra(PaymentActivity.EXTRA_RECEIVER_EMAIL, TOSTRING(USE_PAYPAL_API_EMAIL));
    intent.putExtra(PaymentActivity.EXTRA_PAYMENT, payment);

    startActivityForResult(intent, REQUEST_PAYPAL);
#endif
}

void Paypal_OnActivityResult(int requestCode, int resultCode, Intent data)
{
#if USE_PAYPAL_API
	if (requestCode == REQUEST_PAYPAL)
	{
		if (resultCode == Activity.RESULT_OK) 
		{
			PaymentConfirmation confirm = data.getParcelableExtra(PaymentActivity.EXTRA_RESULT_CONFIRMATION);
			if (confirm != null) 
			{
				try {
					LogI("Paypal_OnActivityResult " + confirm.toJSONObject().toString(4));

					// TODO: send 'confirm' to your server for verification.
					// see https://developer.paypal.com/webapps/developer/docs/integration/mobile/verify-mobile-payment/
					// for more details.
					MyActivity.DispatchLua("gGameInstance","OnPaypalAPISuccess", new String[]{"result", confirm.toJSONObject().toString()});

				} catch (Exception e) {
					LogI("Paypal_OnActivityResult: an extremely unlikely failure occurred: "  + e);
					MyActivity.DispatchLua("gGameInstance","OnPaypalAPIFail", new String[]{"error", "Failure"});
				}
			}
		}
		else if (resultCode == Activity.RESULT_CANCELED) {
			LogI("Paypal_OnActivityResult: The user canceled.");
			MyActivity.DispatchLua("gGameInstance","OnPaypalAPIFail", new String[]{"error", "User canceled"});
		}
		else if (resultCode == PaymentActivity.RESULT_PAYMENT_INVALID) {
			LogI("Paypal_OnActivityResult: An invalid payment was submitted. Please see the docs.");
			MyActivity.DispatchLua("gGameInstance","OnPaypalAPIFail", new String[]{"error", "Invalid payment"});
		}
	}
#endif
}

public static void Paypal_Buy(final String productname, final String price, final String currency, final String userID)
{
#if USE_PAYPAL_API
	s_Activity.runOnUiThread(new Runnable() {
		public void run() {
			s_Activity._Paypal_Buy(price, currency, productname, userID);
		}
	});
#endif
}





