#define PackageManager 	android.content.pm.PackageManager
#define ResolveInfo 	android.content.pm.ResolveInfo
#define ComponentName 	android.content.ComponentName
#define ActivityInfo 	android.content.pm.ActivityInfo
static void ShareActionFacebook_Status(final String message)
{
	s_Activity.runOnUiThread(new Runnable() {
		public void run() {
			try
			{
				LogI("[ShareActionFacebook_Status] " + message);
				Intent shareIntent = new Intent(android.content.Intent.ACTION_SEND);
				shareIntent.setType("text/plain");
				shareIntent.putExtra(android.content.Intent.EXTRA_TEXT, message);
				PackageManager pm = s_Activity.getPackageManager();
				List<ResolveInfo> activityList = pm.queryIntentActivities(shareIntent, 0);
				for (final ResolveInfo app : activityList) {
					if ((app.activityInfo.name).contains("facebook")) {
						final ActivityInfo activity = app.activityInfo;
						final ComponentName name = new ComponentName(activity.applicationInfo.packageName, activity.name);
						shareIntent.addCategory(Intent.CATEGORY_LAUNCHER);
						shareIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_RESET_TASK_IF_NEEDED);
						shareIntent.setComponent(name);
						s_Activity.startActivity(shareIntent);
						break;
				   }
				}
			}
			catch (Exception E)
			{
				E.printStackTrace();
			}
		}
	});
}

static void ShareActionFacebook_Image(final String message, final String image)
{
	s_Activity.runOnUiThread(new Runnable() {
		public void run() {
			try
			{
				LogI("[ShareActionFacebook_Image]\nmessage " + message + "\nimage "+ image);
				Intent shareIntent = new Intent(android.content.Intent.ACTION_SEND);
				shareIntent.setType("image/png");
				
				File imgfile = new File(image);
				Bitmap b = null;
				if(imgfile.exists())
				{
					LogI("[ShareActionFacebook_Image] load from sdcard");
					b =  BitmapFactory.decodeFile(image);
				}
				else
				{
					LogI("[ShareActionFacebook_Image] load from assets");
					b =  GetBitmapFromAsset("assets/" + image);
				}
				
				String filename = SaveBitmap(b, "shared", "fb_" + md5(image), false);
				File file = new File(filename);
				android.net.Uri U = android.net.Uri.fromFile(file);
				
				PackageManager pm = s_Activity.getPackageManager();
				List<ResolveInfo> activityList = pm.queryIntentActivities(shareIntent, 0);
				for (final ResolveInfo app : activityList) {
					if ((app.activityInfo.name).contains("facebook")) {
						final ActivityInfo activity = app.activityInfo;
						final ComponentName name = new ComponentName(activity.applicationInfo.packageName, activity.name);
						shareIntent.putExtra(android.content.Intent.EXTRA_TEXT, message);
						shareIntent.putExtra(android.content.Intent.EXTRA_STREAM, U);
						shareIntent.addCategory(Intent.CATEGORY_LAUNCHER);
						shareIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_RESET_TASK_IF_NEEDED);
						shareIntent.setComponent(name);
						s_Activity.startActivity(shareIntent);
						break;
				   }
				}
			}
			catch (Exception E)
			{
				E.printStackTrace();
			}
		}
	});
}

static void ShareActionTwitter_Status(final String message)
{
	s_Activity.runOnUiThread(new Runnable() {
		public void run() {
			try
			{
				LogI("[ShareActionTwitter_Status] " + message);
				Intent shareIntent = new Intent(android.content.Intent.ACTION_SEND);
				shareIntent.setType("text/plain");
				shareIntent.putExtra(android.content.Intent.EXTRA_TEXT, message);
				PackageManager pm = s_Activity.getPackageManager();
				List<ResolveInfo> activityList = pm.queryIntentActivities(shareIntent, 0);
				for (final ResolveInfo app : activityList) {
					if ((app.activityInfo.name).contains("twitter")) {
						final ActivityInfo activity = app.activityInfo;
						final ComponentName name = new ComponentName(activity.applicationInfo.packageName, activity.name);
						shareIntent.addCategory(Intent.CATEGORY_LAUNCHER);
						shareIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_RESET_TASK_IF_NEEDED);
						shareIntent.setComponent(name);
						s_Activity.startActivity(shareIntent);
						break;
				   }
				}
			}
			catch (Exception E)
			{
				E.printStackTrace();
			}
		}
	});
}

static void ShareActionTwitter_Image(final String message, final String image)
{
	s_Activity.runOnUiThread(new Runnable() {
		public void run() {
			try
			{
				LogI("[ShareActionTwitter_Image]\nmessage " + message + "\nimage "+ image);
				Intent shareIntent = new Intent(android.content.Intent.ACTION_SEND);
				shareIntent.setType("image/png");
				
				File imgfile = new File(image);
				Bitmap b = null;
				if(imgfile.exists())
				{
					LogI("[ShareActionTwitter_Image] load from sdcard");
					b =  BitmapFactory.decodeFile(image);
				}
				else
				{
					LogI("[ShareActionTwitter_Image] load from assets");
					b =  GetBitmapFromAsset("assets/" + image);
				}
				String filename = SaveBitmap(b, "shared", "tw_" + md5(image), false);
				File file = new File(filename);
				android.net.Uri U = android.net.Uri.fromFile(file);
				
				PackageManager pm = s_Activity.getPackageManager();
				List<ResolveInfo> activityList = pm.queryIntentActivities(shareIntent, 0);
				for (final ResolveInfo app : activityList) {
					if ((app.activityInfo.name).contains("twitter")) {
						final ActivityInfo activity = app.activityInfo;
						final ComponentName name = new ComponentName(activity.applicationInfo.packageName, activity.name);
						shareIntent.putExtra(android.content.Intent.EXTRA_TEXT, message);
						shareIntent.putExtra(android.content.Intent.EXTRA_STREAM, U);
						shareIntent.addCategory(Intent.CATEGORY_LAUNCHER);
						shareIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_RESET_TASK_IF_NEEDED);
						shareIntent.setComponent(name);
						s_Activity.startActivity(shareIntent);
						break;
				   }
				}
			}
			catch (Exception E)
			{
				E.printStackTrace();
			}
		}
	});
}


static void ShareAction_Status(final String message)
{
	Intent sendIntent = new Intent();
	sendIntent.setAction(Intent.ACTION_SEND);
	sendIntent.putExtra(Intent.EXTRA_TEXT, message);
	sendIntent.setType("text/plain");
	s_Activity.startActivity(sendIntent);
}

static void ShareAction_SendMail(final String email, final String subject, final String body)
{
	Intent intent = new Intent(Intent.ACTION_VIEW);
	Uri data = Uri.parse("mailto:" + email + "?subject=" + subject + "&body=" + body);
	intent.setData(data);
	s_Activity.startActivity(intent);
}

static void ShareAction_SendMailWithScreenCapture(final String email, final String subject, final String body)
{
	s_Activity.runOnUiThread(new Runnable() {
		boolean att = ((GiderosGLSurfaceView)s_Activity.mGLView).mRenderer.CaptureScreen(0, 0, "screenshot_for_email", null);
		public void run() {
			try
			{
				String extStorageDirectory = Environment.getExternalStorageDirectory().toString() + "//Android//data//" + TOSTRING(ANDROID_PACKAGE_NAME) + "//";

				Intent intent = new Intent(Intent.ACTION_SEND);
				intent.setType("text/plain");
				intent.putExtra(Intent.EXTRA_EMAIL, new String[] {email});
				intent.putExtra(Intent.EXTRA_SUBJECT, subject);
				intent.putExtra(Intent.EXTRA_TEXT, body);

				File root = Environment.getExternalStorageDirectory();
				File file = new File(extStorageDirectory, "screenshot_for_email.png");
				if (att && file.exists() && file.canRead()) {
					Uri uri = Uri.parse("file://" + file.getAbsolutePath());
					intent.putExtra(Intent.EXTRA_STREAM, uri);
				}

				PackageManager pm = s_Activity.getPackageManager();
				List<ResolveInfo> activityList = pm.queryIntentActivities(intent, 0);
				for (final ResolveInfo app : activityList) {
					if ((app.activityInfo.name).contains("mail")) {
						final ActivityInfo activity = app.activityInfo;
						final ComponentName name = new ComponentName(activity.applicationInfo.packageName, activity.name);
						intent.setComponent(name);
						s_Activity.startActivity(intent);
					}
				}
			}
			catch (Exception E)
			{
				E.printStackTrace();
			}
		}
	});
}

static void ShareAction_Image(final String message, final String image)
{
	Intent sendIntent = new Intent();
	sendIntent.setAction(Intent.ACTION_SEND);

	File imgfile = new File(image);
	Bitmap b = null;
	if(imgfile.exists())
	{
		LogI("[ShareActionTwitter_Image] load from sdcard");
		b =  BitmapFactory.decodeFile(image);
	}
	else
	{
		LogI("[ShareActionTwitter_Image] load from assets");
		b =  GetBitmapFromAsset("assets/" + image);
	}
	String filename = SaveBitmap(b, "shared", "common_" + md5(image), false);
	File file = new File(filename);
	android.net.Uri U = android.net.Uri.fromFile(file);	
	
	sendIntent.setType("image/png");
	sendIntent.putExtra(android.content.Intent.EXTRA_TEXT, message);
	sendIntent.putExtra(android.content.Intent.EXTRA_STREAM, U);
	s_Activity.startActivity(sendIntent);
}

#undef PackageManager
#undef ResolveInfo
#undef ComponentName
#undef ActivityInfo
