#if USE_INMOBI_ADS
private IMInterstitial m_imAdInterstitial;
#endif

public static void InmobiAds_OnCreate()
{
#if USE_INMOBI_ADS
	Log("InmobiAds_OnCreate");
	if (s_Activity != null)
	{
		IMInterstitial imAdInterstitial = new IMInterstitial(s_Activity, TOSTRING(USE_INMOBI_APPID));
		imAdInterstitial.setIMInterstitialListener(s_Activity.m_imAdInterstitialDelegate);
		imAdInterstitial.loadInterstitial();
		s_Activity.m_imAdInterstitial = imAdInterstitial;
	}
#endif
}

public static void InMobiAds_OnDestroy()
{
#if USE_INMOBI_ADS
	if(s_Activity.m_imAdInterstitial!=null) 
	{
		// s_Activity.m_imAdInterstitial.destroy();
	}
	s_Activity.m_imAdInterstitial = null;
#endif
}


public static int InMobiAds_Show()
{
#if USE_INMOBI_ADS
	Log("InMobiAds_Show " + s_Activity.m_imAdInterstitial.getState());
	
	if(IMInterstitial.State.READY.equals(s_Activity.m_imAdInterstitial.getState())) 
	{
		s_Activity.runOnUiThread(new Runnable() {
			public void run() {
				s_Activity.m_imAdInterstitial.show();
			}
		});
		return 1;
	}
	s_Activity.m_imAdInterstitial.loadInterstitial();
	return 0;
#else
	LogI("[InmobiAds_Show] USE_INMOBI_ADS is 0");
	return 0;
#endif
}

#if USE_INMOBI_ADS
	private IMInterstitialListener m_imAdInterstitialDelegate = new IMInterstitialListener() {
		@Override
		public void onInterstitialFailed(IMInterstitial interstitial, IMErrorCode errorCode)
		{
			LogI("[IMAdInterstitialListener-onInterstitialFailed] " + errorCode);
		}
		@Override
		public void onInterstitialLoaded(IMInterstitial adInterstitial)
		{
			LogI("[IMAdInterstitialListener-onInterstitialLoaded]");
		}
		@Override
		public void onShowInterstitialScreen(IMInterstitial adInterstitial)
		{
			LogI("[IMAdInterstitialListener-onShowInterstitialScreen]");
		}
		@Override
		public void onDismissInterstitialScreen(IMInterstitial adInterstitial)
		{
			LogI("[IMAdInterstitialListener-onDismissInterstitialScreen]");
			m_imAdInterstitial.loadInterstitial();
		}
		@Override
		public void onLeaveApplication(IMInterstitial adInterstitial)
		{
		}
		@Override
		public void onInterstitialInteraction(IMInterstitial interstitial, Map<String, String> arg1) {}
	};
#endif