VideoView mVideoView;
RelativeLayout mVideoLayout;
MediaController mMediaController;

void Video_Init()
{
	mVideoLayout = new RelativeLayout(this);
	mVideoLayout.setLayoutParams(new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.FILL_PARENT, RelativeLayout.LayoutParams.FILL_PARENT));
	mVideoLayout.setBackgroundColor(0xff000000);

	mVideoView = new VideoView(this);
	RelativeLayout.LayoutParams params = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.FILL_PARENT, RelativeLayout.LayoutParams.FILL_PARENT);
	params.addRule(RelativeLayout.CENTER_IN_PARENT, RelativeLayout.TRUE);
	mVideoView.setVisibility(View.VISIBLE);
	mVideoView.setLayoutParams(params);

	mVideoLayout.addView(mVideoView);

	mMediaController = new MediaController(this);
	mMediaController.setAnchorView(mVideoView);
	mMediaController.setMediaPlayer(mVideoView);
	mVideoView.setMediaController(mMediaController);

	mVideoView.setOnCompletionListener(new MediaPlayer.OnCompletionListener() {
		@Override
		public void onCompletion(MediaPlayer vmp) {
			s_Activity.Video_Hide();    
		}
	});  

	mVideoView.setOnErrorListener(new MediaPlayer.OnErrorListener() {
		@Override
		public boolean onError(MediaPlayer mp, int what, int extra) {
			LogI("[Video_Show] OnErrorListener " + what + " " + extra);
			s_Activity.Video_Hide();
			return false;
		}
	});
}


static void Video_Show(final String filename)
{
	s_Activity.runOnUiThread(new Runnable() {
		public void run() {
			File file = s_Activity.CacheFileFromAssetToSDCard(filename);
			if(file == null || !file.exists()) {
				MyActivity.DispatchLua("gGameInstance","bridge_OnEndVideo", new String[]{});
				LogI("Video " + filename + " not found");
				return;
			}
			android.net.Uri uri = android.net.Uri.fromFile(file);
			s_Activity.m_MyLayout.addView(s_Activity.mVideoLayout);
			s_Activity.mVideoView.setZOrderOnTop(true);
			s_Activity.mVideoView.setVideoURI(uri);
			s_Activity.mVideoView.requestFocus();
			s_Activity.mMediaController.show();
			s_Activity.mVideoView.start();
		}
	});
	
}

static void Video_Hide()
{
	s_Activity.runOnUiThread(new Runnable() {
		public void run() {
			s_Activity.m_MyLayout.removeView(s_Activity.mVideoLayout);
			s_Activity.mVideoView.stopPlayback();
			s_Activity.mMediaController.hide();
			MyActivity.DispatchLua("gGameInstance","bridge_OnEndVideo", new String[]{});
		}
	});
}