WebView myWebView;
boolean isShowingWebView = false;

public class MyJavaScriptInterface {
	Context mContext;
	MyJavaScriptInterface(Context c) {
		mContext = c;
	}
    
	public void closeView(){
		MyActivity.s_Activity.WebView_Hide();
	}
};

void WebView_Init()
{
	myWebView = new WebView(this);
	WebSettings webSettings = myWebView.getSettings();
	webSettings.setJavaScriptEnabled(true);
	myWebView.setScrollContainer(false);
	myWebView.setBackgroundColor(0x00000000);
	if (Build.VERSION.SDK_INT >= 11) myWebView.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
	myWebView.setWebViewClient(new android.webkit.WebViewClient(){
		@Override
		public void onPageFinished(WebView view, String url)
		{
			myWebView.setBackgroundColor(0x00000000);
			if (Build.VERSION.SDK_INT >= 11) myWebView.setLayerType(WebView.LAYER_TYPE_SOFTWARE, null);
		}
	});
	RelativeLayout.LayoutParams params = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.FILL_PARENT, RelativeLayout.LayoutParams.FILL_PARENT);
    myWebView.setLayoutParams(params);

	final MyJavaScriptInterface myJavaScriptInterface = new MyJavaScriptInterface(this);
	myWebView.addJavascriptInterface(myJavaScriptInterface, "Android");
}

static void WebView_Show()
{
	s_Activity.SendMessge(MESSAGE_WEBVIEW_SHOW);
}

static void WebView_Hide()
{
	s_Activity.SendMessge(MESSAGE_WEBVIEW_HIDE);
}

static void WebView_Load(final String url)
{
	s_Activity.runOnUiThread(new Runnable() {
		public void run() {
			s_Activity.myWebView.loadUrl(url);
		}
	});
}

static void WebView_ShowAsActivity(final String url)
{
	if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.HONEYCOMB) {
		s_Activity.runOnUiThread(new Runnable() {
			public void run() {
				Intent i = new Intent(MyActivity.s_Activity, CWebViewPage.class);
				i.putExtra("url", url);
				MyActivity.s_Activity.startActivity(i);
			}
		});
	}
	else {
		s_Activity.runOnUiThread(new Runnable() {
			public void run() {
				Intent browserIntent = new Intent(Intent.ACTION_VIEW, Uri.parse(url));
				MyActivity.s_Activity.startActivity(browserIntent);
			}
		});
	}
}




